Package: primitives

## [Java] Class long[]

- primitives.long[]

-     public class long[]
      extends Object

  GDK enhancements for long[].

  displayName:
    long[]
  receiverFqcn:
    long[]

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public boolean` | `any(Closure<?> predicate)` Iterates over the contents of a long Array, and checks whether a predicate is valid for at least one element.
    `` | `public boolean` | `any(LongPredicate predicate)` Returns true if any element of the long array matches the given predicate.
    `` | `public boolean` | `asBoolean()` Coerces a long array to a boolean value.
    `` | `public BigDecimal` | `average()` Calculates the average of the longs in the array.
    `` | `public List<List<Long>>` | `chop(int chopSizes)` Chops the long array into pieces, returning lists with sizes corresponding to the supplied chop sizes.
    `` | `public boolean` | `contains(Object value)` Checks whether the array contains the given value.
    `` | `public Number` | `count(Object value)` Counts the number of occurrences of the given value inside this array.
    `` | `public Number` | `count(LongPredicate predicate)` Counts the number of elements in the long array matching the given predicate.
    `` | `public long[]` | `each(LongConsumer consumer)` Iterates through a long[] passing each long to the given consumer.
    `` | `public long[]` | `each(Closure<?> closure)` Iterates through a long[] passing each long to the given closure.
    `` | `public long[]` | `eachWithIndex(Closure<?> closure)` Iterates through a long[], passing each long and the element's index (a counter starting at zero) to the given closure.
    `` | `public boolean` | `equals(long[] right)` Compares the contents of this array to the contents of the given array.
    `` | `public boolean` | `every(Closure<?> predicate)` Iterates over the contents of a long Array, and checks whether a predicate is valid for all elements.
    `` | `public boolean` | `every(LongPredicate predicate)` Returns true if every element of the long array matches the given predicate.
    `` | `public long` | `first()` Returns the first item from the long array.
    `` | `public List<Long>` | `flatten()` Flattens an array.
    `` | `public List<Long>` | `getAt(Range<?> range)` Supports the subscript operator for a long array with a range giving the desired indices.
    `` | `public List<Long>` | `getAt(IntRange range)` Supports the subscript operator for a long array with an IntRange giving the desired indices.
    `` | `public List<Long>` | `getAt(ObjectRange range)` Supports the subscript operator for a long array with an ObjectRange giving the desired indices.
    `` | `public List<Long>` | `getAt(Collection<?> indices)` Supports the subscript operator for a long array with a (potentially nested) collection giving the desired indices.
    `` | `public IntRange` | `getIndices()` Returns indices of the long array.
    `` | `public String` | `groovyToString()` Returns Groovy's list-like string representation for a long array.
    `` | `public long` | `head()` Returns the first item from the long array.
    `` | `public Map<Integer, Long>` | `indexed()` Zips a long[] with indices in (index, value) order starting from index 0.
    `` | `public Map<Integer, Long>` | `indexed(int offset)` Zips a long[] with indices in (index, value) order starting from a given index.
    `` | `public long[]` | `init()` Returns the items from the long array excluding the last item.
    `` | `public boolean` | `isSorted()` Determines if the array is sorted in natural (ascending) order.
    `` | `public String` | `join()` Concatenates the string representation of each item in this array.
    `` | `public String` | `join(String separator)` Concatenates the string representation of each item in this array, with the given String as a separator between each item.
    `` | `public long` | `last()` Returns the last item from the long array.
    `` | `public LongStream` | `longStream()` Returns a sequential LongStream with the specified array as its source.
    `` | `public long` | `max()` Adds max() method to long arrays.
    `` | `public long` | `max(LongComparator comparator)` Selects the maximum value found from the long array using the supplied LongBinaryOperator as a comparator to determine the maximum of any two values.
    `` | `public long` | `max(LongUnaryOperator operator)` Selects the maximum value found from the long array using the supplied LongUnaryOperator to determine the maximum of any two values.
    `` | `public long` | `maxComparing(Comparator<Long> comparator)` Selects the maximum value found from the long array using the comparator to determine the maximum of any two values.
    `` | `public long` | `min()` Adds min() method to long arrays.
    `` | `public long` | `min(LongComparator comparator)` Selects the minimum value found from the long array using the supplied LongComparator to determine the minimum of any two values.
    `` | `public long` | `min(LongUnaryOperator operator)` Selects the minimum value found from the long array using the supplied LongUnaryOperator to determine the minimum of any two values.
    `` | `public long` | `minComparing(Comparator<Long> comparator)` Selects the minimum value found from the long array using the comparator to determine the minimum of any two values.
    `` | `public int` | `partitionPoint(IntRange range, LongPredicate condition)` Returns the index of the partition point according to the given predicate (the index of the first element of the second partition).
    `` | `public int` | `partitionPoint(LongPredicate condition)` Returns the index of the partition point according to the given predicate (the index of the first element of the second partition).
    `` | `public void` | `putAt(IntRange range, long[] source)` A helper method to allow arrays to be set with subscript operators.
    `` | `public void` | `putAt(IntRange range, Iterable<Number> source)` A helper method to allow arrays to be set with subscript operators.
    `` | `public long[]` | `reverse()` Creates a new long array containing items which are the same as this array but in reverse order.
    `` | `public long[]` | `reverse(boolean mutate)` Reverses the items in an array.
    `` | `public long[]` | `reverseEach(Closure<?> closure)` Iterates through a long[] in reverse order passing each long to the given closure.
    `` | `public int` | `size()` Provides arrays with a `size` method similar to collections.
    `` | `public Stream<Long>` | `stream()` Returns a sequential Stream with the specified array as its source.
    `` | `public long` | `sum()` Sums the items in an array.
    `` | `public long` | `sum(LongUnaryOperator operator)` Calculates the sum of values found from applying the operator to members of the int array.
    `` | `public long` | `sum(long initialValue)` Sums the items in an array, adding the result to some initial value.
    `` | `public long[]` | `swap(int i, int j)` Swaps two elements at the specified positions.
    `` | `public long[]` | `tail()` Returns the items from the long array excluding the first item.
    `` | `public List<Long>` | `toImmutableList()` Converts this array to an immutable List of the same size, with each element added to the list.
    `` | `public Set<Long>` | `toImmutableSet()` Converts this array to an immutable Set, with each unique element added to the set.
    `` | `public List<Long>` | `toList()` Converts this array to a List of the same size, with each element added to the list.
    `` | `public Set<Long>` | `toSet()` Converts this array to a Set, with each unique element added to the set.
    `` | `public String` | `toString()` Returns the string representation of the given array.
    `` | `public List<Tuple2<Long, Integer>>` | `withIndex()` Zips a long array with indices in (value, index) order.
    `` | `public List<Tuple2<Long, Integer>>` | `withIndex(int offset)` Zips a long array with indices in (value, index) order starting from a given index.
    `` | `public List<Tuple2<Long, Long>>` | `zip(long[] other)` A list of all the pairs from two arrays.
    `` | `public Iterator<Tuple2<Long, Long>>` | `zipping(long[] other)` An iterator of all the pairs from two arrays.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `addShutdownHook, any, any, asBoolean, asType, clamp, clamp, collect, collect, collect, dump, each, eachMatch, eachMatch, eachWithIndex, every, every, find, find, findAll, findAll, findIndexOf, findIndexOf, findIndexValues, findIndexValues, findLastIndexOf, findLastIndexOf, findResult, findResult, findResult, findResult, getAt, getMetaClass, getMetaPropertyValues, getProperties, grep, grep, hasProperty, identity, inject, inject, inject, inject, inspect, invokeMethod, is, isCase, isNotCase, iterator, metaClass, print, print, printf, printf, println, println, println, putAt, respondsTo, respondsTo, setMetaClass, sleep, sleep, split, sprintf, sprintf, stream, takeIf, tap, toString, use, use, use, with, with, withCloseable, withCloseable, withMethodClosure, withStream, withStream, withTraits`

- - ### Method Detail

    - #### public boolean any(Closure<?> predicate)

      Iterates over the contents of a long Array, and checks whether a predicate is valid for at least one element.

           long[] array = [0L, 1L, 2L]
           assert array.any{ it > 1L }
           assert !array.any{ it > 3L }

      Parameters:
        `predicate` - the closure predicate used for matching
      Returns:
        true if any iteration for the longs matches the closure predicate
      Since:
        5.0.0

    - #### public boolean any(LongPredicate predicate)

      Returns true if any element of the long array matches the given predicate. A "fat-free" variant of long accepting a LongPredicate.

           long[] nums = [1L, 2L, 3L]
           assert nums.any(n -> n > 2)

      Parameters:
        `predicate` - the predicate evaluated against each element
      Returns:
        true if any element satisfies the predicate
      Since:
        6.0.0

    - #### public boolean asBoolean()

      Coerces a long array to a boolean value. A long array is false if the array is of length 0, and true otherwise.

      Returns:
        the array's boolean value
      Since:
        1.7.4

    - #### public BigDecimal average()

      Calculates the average of the longs in the array.

          assert 5.0G == ([2,4,6,8] as long[]).average()

      Returns:
        The average of the items
      Since:
        3.0.0

    - #### public List<List<Long>> chop(int chopSizes)

      Chops the long array into pieces, returning lists with sizes corresponding to the supplied chop sizes. If the array isn't large enough, truncated (possibly empty) pieces are returned. Using a chop size of -1 will cause that piece to contain all remaining items from the array.

           long[] array = [0, 1, 2]
           assert array.chop(1, 2) == [[0], [1, 2]]

      Parameters:
        `chopSizes` - the sizes for the returned pieces
      Returns:
        a list of lists chopping the original array elements into pieces determined by chopSizes
      See Also:
        ArrayGroovyMethods#collate(Object[], int)#collate(Object[], int)
      Since:
        5.0.0

    - #### public boolean contains(Object value)

      Checks whether the array contains the given value.

      Parameters:
        `value` - the value being searched for
      Returns:
        true if the array contains the value
      Since:
        1.8.6

    - #### public Number count(Object value)

      Counts the number of occurrences of the given value inside this array. Comparison is done using Groovy's == operator (using `compareTo(value) == 0`).

           long[] array = [10L, 20L, 20L, 30L]
           assert array.count(20L) == 2

      Parameters:
        `value` - the value being searched for
      Returns:
        the number of occurrences
      See Also:
        DefaultGroovyMethods#count(Iterator, Object)#count(Iterator, Object)
      Since:
        1.6.4

    - #### public Number count(LongPredicate predicate)

      Counts the number of elements in the long array matching the given predicate. The primitive-array counterpart of Object, accepting a LongPredicate. A value passed instead of a predicate selects long (value equality).

           long[] nums = [1L, 2L, 3L, 4L, 5L]
           assert nums.count(n -> n % 2 == 0) == 2

      Parameters:
        `predicate` - the predicate evaluated against each element
      Returns:
        the number of elements matching the predicate
      Since:
        6.0.0

    - #### public long[] each(LongConsumer consumer)

      Iterates through a long[] passing each long to the given consumer.

           long[] array = [0L, 1L, 2L]
           String result = ''
           array.each{ result += it }
           assert result == '012'

      Parameters:
        `consumer` - the consumer for each long
      Returns:
        the self array
      Since:
        5.0.0

    - #### public long[] each(Closure<?> closure)

      Iterates through a long[] passing each long to the given closure.

           long[] array = [0L, 1L, 2L]
           String result = ''
           array.each{ result += it }
           assert result == '012'

      Parameters:
        `closure` - the closure applied on each long
      Returns:
        the self array
      Since:
        6.0.0

    - #### public long[] eachWithIndex(Closure<?> closure)

      Iterates through a long[], passing each long and the element's index (a counter starting at zero) to the given closure.

           long[] array = [10L, 20L, 30L]
           String result = ''
           array.eachWithIndex{ item, index -> result += "$index($item)" }
           assert result == '0(10)1(20)2(30)'

      Parameters:
        `closure` - a Closure to operate on each long
      Returns:
        the self array
      Since:
        5.0.0

    - #### public boolean equals(long[] right)

      Compares the contents of this array to the contents of the given array.

      Example usage:

           long[] array1 = [4L, 8L]
           long[] array2 = [4L, 8L]
           assert array1 !== array2
           assert array1.equals(array2)

      Parameters:
        `right` - the array being compared
      Returns:
        true if the contents of both arrays are equal.
      Since:
        5.0.0

    - #### public boolean every(Closure<?> predicate)

      Iterates over the contents of a long Array, and checks whether a predicate is valid for all elements.

           long[] array = [0L, 1L, 2L]
           assert array.every{ it < 3L }
           assert !array.every{ it > 1L }

      Parameters:
        `predicate` - the closure predicate used for matching
      Returns:
        true if the predicate returns true for all elements in the array
      Since:
        5.0.0

    - #### public boolean every(LongPredicate predicate)

      Returns true if every element of the long array matches the given predicate. A "fat-free" variant of long accepting a LongPredicate.

           long[] nums = [2L, 4L, 6L]
           assert nums.every(n -> n % 2 == 0)

      Parameters:
        `predicate` - the predicate evaluated against each element
      Returns:
        true if every element satisfies the predicate
      Since:
        6.0.0

    - #### public long first()

      Returns the first item from the long array.

           long[] longs = [2L, 4L, 6L]
           assert longs.first() == 2L

      An alias for `head()`.
      throws:
        NoSuchElementException if the array is empty
      Returns:
        the first element
      Since:
        5.0.0

    - #### public List<Long> flatten()

      Flattens an array. This array is added to a new collection. It is an alias for `toList()` but allows algorithms to be written which also work on multidimensional arrays or non-arrays where flattening would be applicable.

           long[] array = [0L, 1L]
           assert array.flatten() == [0L, 1L]

      Returns:
        a Collection of the array elements
      Since:
        1.6.0

    - #### public List<Long> getAt(Range<?> range)

      Supports the subscript operator for a long array with a range giving the desired indices.

           long[] array = [1L, 3L, 5L, 7L, 9L, 11L]
           assert array[2..<2] == [] // EmptyRange
           assert array[(0..5.5).step(2)] == [1L, 5L, 9L]   // NumberRange
           assert array[(1..5.5).step(2)] == [3L, 7L, 11L]  // NumberRange

      Parameters:
        `range` - a range indicating the indices for the items to retrieve
      Returns:
        list of the retrieved longs
      Since:
        1.0

    - #### public List<Long> getAt(IntRange range)

      Supports the subscript operator for a long array with an IntRange giving the desired indices.

           long[] array = [0L, 10L, 20L, 30L, 40L]
           assert array[2..3] == [20L, 30L]
           assert array[-2..-1] == [30L, 40L]
           assert array[-1..-2] == [40L, 30L]

      Parameters:
        `range` - an IntRange indicating the indices for the items to retrieve
      Returns:
        list of the retrieved longs
      Since:
        1.0

    - #### public List<Long> getAt(ObjectRange range)

      Supports the subscript operator for a long array with an ObjectRange giving the desired indices.

           long[] array = [0L, 10L, 20L, 30L, 40L]
           def range = new ObjectRange(2, 3)
           assert array[range] == [20L, 30L]

      Parameters:
        `range` - an ObjectRange indicating the indices for the items to retrieve
      Returns:
        list of the retrieved longs
      Since:
        1.0

    - #### public List<Long> getAt(Collection<?> indices)

      Supports the subscript operator for a long array with a (potentially nested) collection giving the desired indices.

           long[] array = [0L, 2L, 4L, 6L, 8L]
           assert array[2, 3] == [4L, 6L]
           assert array[1, 0..1, [0, [-1]]] == [2L, 0L, 2L, 0L, 8L]

      Parameters:
        `indices` - a collection of indices for the items to retrieve
      Returns:
        list of the longs at the given indices
      Since:
        1.0

    - #### public IntRange getIndices()

      Returns indices of the long array.

           long[] array = [0L, 1L]
           assert array.indices == 0..1

      See Also:
        ArrayGroovyMethods#getIndices(Object[])#getIndices(Object[])
      Since:
        3.0.8

    - #### public String groovyToString()

      Returns Groovy's list-like string representation for a long array.

      If disabled, e.g. via `-Dgroovy.extension.disable=groovyToString(long[])`, the JDK's default array `toString()` is used instead.

      Returns:
        the string representation
      Since:
        6.0.0

    - #### public long head()

      Returns the first item from the long array.

           long[] longs = [2L, 4L, 6L]
           assert longs.head() == 2L

      An alias for `first()`.
      throws:
        NoSuchElementException if the array is empty
      Returns:
        the first element
      Since:
        5.0.0

    - #### public Map<Integer, Long> indexed()

      Zips a long[] with indices in (index, value) order starting from index 0.

      Example usage:

           long[] nums = [10L, 20L, 30L]
           assert [0: 10L, 1: 20L, 2: 30L] == nums.indexed()

      See Also:
        indexed(long[], int)
      Since:
        3.0.8

    - #### public Map<Integer, Long> indexed(int offset)

      Zips a long[] with indices in (index, value) order starting from a given index.

      Example usage:

           long[] nums = [10L, 20L, 30L]
           assert [5: 10L, 6: 20L, 7: 30L] == nums.indexed(5)

      Parameters:
        `offset` - an index to start from
      Returns:
        a Map (since the keys/indices are unique) containing the elements from the iterable zipped with indices
      See Also:
        DefaultGroovyMethods#indexed(Iterable, int)#indexed(Iterable, int)
      Since:
        3.0.8

    - #### public long[] init()

      Returns the items from the long array excluding the last item.

           long[] longs = [2L, 4L, 6L]
           def result = longs.init()
           assert result == [2L, 4L]
           assert longs.class.componentType == result.class.componentType

      throws:
        UnsupportedOperationException if the array is empty
      Returns:
        an array without its last element
      Since:
        5.0.0

    - #### public boolean isSorted()

      Determines if the array is sorted in natural (ascending) order. This is efficient — it checks adjacent pairs in a single pass and short-circuits on the first out-of-order pair.

           long[] nums = [1L, 2L, 3L]
           assert nums.isSorted()
           long[] unsorted = [3L, 1L, 2L]
           assert !unsorted.isSorted()

      Returns:
        true if the array elements are sorted in non-descending order
      Since:
        6.0.0

    - #### public String join()

      Concatenates the string representation of each item in this array.

      Returns:
        the joined String
      Since:
        5.0.0

    - #### public String join(String separator)

      Concatenates the string representation of each item in this array, with the given String as a separator between each item.

      Parameters:
        `separator` - a String separator
      Returns:
        the joined String
      Since:
        2.4.1

    - #### public long last()

      Returns the last item from the long array.

           long[] longs = [2L, 4L, 6L]
           assert longs.last() == 6L

      throws:
        NoSuchElementException if the array is empty
      Returns:
        the last element
      Since:
        5.0.0

    - #### public LongStream longStream()

      Returns a sequential LongStream with the specified array as its source.

      Returns:
        a `Stream` for the array
      Since:
        3.0.8

    - #### public long max()

      Adds max() method to long arrays.

      Example usage:

           long[] nums = [1L, 3L, 2L]
           assert 3L == nums.max()

      Returns:
        the maximum value
      Since:
        3.0.8

    - #### public long max(LongComparator comparator)

      Selects the maximum value found from the long array using the supplied LongBinaryOperator as a comparator to determine the maximum of any two values.

           long[] nums = [10L, 20L, -30L]
           assert 20L == nums.max{ n, m -> n <=> m }
           assert -30L == nums.max{ n, m -> n.abs() <=> m.abs() }

      throws:
        UnsupportedOperationException if the array is empty
      Parameters:
        `comparator` - a comparator, i.e. returns a negative value if the first parameter is less than the second
      Returns:
        the maximum value
      Since:
        5.0.0

    - #### public long max(LongUnaryOperator operator)

      Selects the maximum value found from the long array using the supplied LongUnaryOperator to determine the maximum of any two values. The operator is applied to each array element and the results are compared.

           long[] nums = [10L, 20L, -30L]
           assert 20L == nums.max{ it }
           assert -30L == nums.max{ it.abs() }

      throws:
        UnsupportedOperationException if the array is empty
      Parameters:
        `operator` - an operator that returns a long used for comparing values
      Returns:
        the maximum value
      Since:
        5.0.0

    - #### public long maxComparing(Comparator<Long> comparator)

      Selects the maximum value found from the long array using the comparator to determine the maximum of any two values.

           long[] nums = [10L, 20L, 30L]
           assert 30L == nums.maxComparing(Comparator.naturalOrder())
           assert 10L == nums.maxComparing(Comparator.reverseOrder())

      Parameters:
        `comparator` - a Comparator
      Returns:
        the maximum value
      See Also:
        DefaultGroovyMethods#max(Iterator, java.util.Comparator)
      Since:
        5.0.0

    - #### public long min()

      Adds min() method to long arrays.

      Example usage:

           long[] nums = [20L, 10L, 30L]
           assert 10L == nums.min()

      Returns:
        the minimum value
      Since:
        3.0.8

    - #### public long min(LongComparator comparator)

      Selects the minimum value found from the long array using the supplied LongComparator to determine the minimum of any two values.

           long[] nums = [10L, -20L, 30L]
           assert -20L == nums.min{ n, m -> n <=> m }
           assert 10L == nums.min{ n, m -> n.abs() <=> m.abs() }

      throws:
        UnsupportedOperationException if the array is empty
      Parameters:
        `comparator` - a comparator, i.e. returns a negative value if the first parameter is less than the second
      Returns:
        the minimum value
      Since:
        5.0.0

    - #### public long min(LongUnaryOperator operator)

      Selects the minimum value found from the long array using the supplied LongUnaryOperator to determine the minimum of any two values. The operator is applied to each array element and the results are compared.

           long[] nums = [10L, -20L, 30L]
           assert -20L == nums.min{ it }
           assert 10L == nums.min{ it.abs() }

      throws:
        UnsupportedOperationException if the array is empty
      Parameters:
        `operator` - an operator that returns a long used for comparing values
      Returns:
        the minimum value
      Since:
        5.0.0

    - #### public long minComparing(Comparator<Long> comparator)

      Selects the minimum value found from the long array using the comparator to determine the minimum of any two values.

           long[] nums = [10L, 20L, 30L]
           assert 10L == nums.minComparing(Comparator.naturalOrder())
           assert 30L == nums.minComparing(Comparator.reverseOrder())

      Parameters:
        `comparator` - a Comparator
      Returns:
        the minimum value
      See Also:
        DefaultGroovyMethods#min(Iterator, java.util.Comparator)
      Since:
        5.0.0

    - #### public int partitionPoint(IntRange range, LongPredicate condition)

      Returns the index of the partition point according to the given predicate (the index of the first element of the second partition). The arr is assumed to be partitioned according to the given predicate.

           def arr = [7, 15, 3, 5, 4, 12, 6] as long[]
           assert arr.partitionPoint(0..<arr.size()) { it%2 != 0 } == 4

           def arr = [1, 2, 3, 3, 4, 4, 5, 6, 7] as long[]
           // usage case like lower_bound(cpp), bisect_left(python)
           assert arr.partitionPoint(0..<arr.size()) { it < 4 } == 4
           // usage case like upper_bound(cpp), bisect_right(python)
           assert arr.partitionPoint(0..<arr.size()) { it <= 4 } == 6
           // for all match condition
           assert arr.partitionPoint(0..<arr.size()) { it <= 100 } == arr.size()
           // for no match condition
           assert arr.partitionPoint(0..<arr.size()) { it <= 0 } == 0
           // for no match condition with range
           assert arr.partitionPoint(2..<arr.size()) { it <= 0 } == 2

      Parameters:
        `range` - the range [l,r] to find data match the condition
        `condition` - the matching condition
      Returns:
        an integer that is the index of the first element of the second partition
      Since:
        5.0.0

    - #### public int partitionPoint(LongPredicate condition)

      Returns the index of the partition point according to the given predicate (the index of the first element of the second partition). The arr is assumed to be partitioned according to the given predicate.

           def arr = [7, 15, 3, 5, 4, 12, 6] as long[]
           assert arr.partitionPoint{ it%2 != 0 } == 4

           def arr = [1, 2, 3, 3, 4, 4, 5, 6, 7] as long[]
           // usage case like lower_bound(cpp), bisect_left(python)
           assert arr.partitionPoint{ it < 4 } == 4
           // usage case like upper_bound(cpp), bisect_right(python)
           assert arr.partitionPoint{ it <= 4 } == 6
           // for all match condition
           assert arr.partitionPoint{ it <= 100 } == arr.size()
           // for no match condition
           assert arr.partitionPoint{ it <= 0 } == 0
           // empty input
           assert (new long[0]).partitionPoint{ it < 4 } == 0

      Parameters:
        `condition` - the matching condition
      Returns:
        an integer that is the index of the first element of the second partition
      Since:
        5.0.0

    - #### public void putAt(IntRange range, long[] source)

      A helper method to allow arrays to be set with subscript operators.

           long[] from = [1L, 1L, 1L]
           long[] to = [0L, 0L, 0L, 0L, 0L]
           to[1..3] = from
           assert to == [0L, 1L, 1L, 1L, 0L]

      throws:
        IndexOutOfBoundsException if the source doesn't have sufficient elements or the IntRange is too big for the self array
      Parameters:
        `range` - the subset of the array to set
        `source` - the source array from which new values will come
      Since:
        5.0.0

    - #### public void putAt(IntRange range, Iterable<Number> source)

      A helper method to allow arrays to be set with subscript operators. Zero will be used if the source iterable has insufficient elements.

           def from = [1L, 1L, 1L]
           long[] to = [0L, 0L, 0L, 0L, 0L]
           to[1..3] = from
           assert to == [0L, 1L, 1L, 1L, 0L]

      Parameters:
        `range` - the subset of the array to set
        `source` - the source array from which new values will come
      Since:
        5.0.0

    - #### public long[] reverse()

      Creates a new long array containing items which are the same as this array but in reverse order.

           long[] array = 1L..2L
           assert array.reverse() == 2L..1L

      Returns:
        an array containing the reversed items
      See Also:
        reverse(long[], boolean)
      Since:
        5.0.0

    - #### public long[] reverse(boolean mutate)

      Reverses the items in an array. If mutate is true, the original array is modified in place and returned. Otherwise, a new array containing the reversed items is produced.

           long[] array = 1L..3L
           def yarra = array.reverse(true)
           assert array == 3L..1L
           assert yarra == 3L..1L
           assert array === yarra
           yarra = array.reverse(false)
           assert array !== yarra
           assert array == 3L..1L
           assert yarra == 1L..3L

      Parameters:
        `mutate` - `true` if the array itself should be reversed in place, `false` if a new array should be created
      Returns:
        an array containing the reversed items
      Since:
        5.0.0

    - #### public long[] reverseEach(Closure<?> closure)

      Iterates through a long[] in reverse order passing each long to the given closure.

           long[] array = [0, 1, 2]
           String result = ''
           array.reverseEach{ result += it }
           assert result == '210'

      Parameters:
        `closure` - the closure applied on each long
      Returns:
        the self array
      Since:
        5.0.0

    - #### public int size()

      Provides arrays with a `size` method similar to collections.

      Returns:
        the length of the array
      Since:
        1.0

    - #### public Stream<Long> stream()

      Returns a sequential Stream with the specified array as its source.

      Returns:
        a `Stream` for the array
      Since:
        2.5.0

    - #### public long sum()

      Sums the items in an array.

          assert (1+2+3+4 as long) == ([1,2,3,4] as long[]).sum()

      Returns:
        The sum of all the items
      Since:
        2.4.2

    - #### public long sum(LongUnaryOperator operator)

      Calculates the sum of values found from applying the operator to members of the int array.

           int[] nums = [10, -20, 30]
           assert 20 == nums.sum{ n -> n }
           assert 60 == nums.sum{ n -> n.abs() }

      throws:
        UnsupportedOperationException if the array is empty
      Parameters:
        `operator` - an operator that returns a long used for summing values
      Returns:
        the sum value of all values after applying the operator
      Since:
        5.0.0

    - #### public long sum(long initialValue)

      Sums the items in an array, adding the result to some initial value.

          assert (5+1+2+3+4 as long) == ([1,2,3,4] as long[]).sum(5)

      Parameters:
        `initialValue` - the items in the array will be summed to this initial value
      Returns:
        The sum of all the items.
      Since:
        2.4.2

    - #### public long[] swap(int i, int j)

      Swaps two elements at the specified positions.

      Example:

           assert ([1, 3, 2, 4] as long[]) == ([1, 2, 3, 4] as long[]).swap(1, 2)

      Parameters:
        `i` - a position
        `j` - a position
      Returns:
        self
      Since:
        2.4.0

    - #### public long[] tail()

      Returns the items from the long array excluding the first item.

           long[] longs = [2L, 4L, 6L]
           def result = longs.tail()
           assert result == [4L, 6L]
           assert longs.class.componentType == result.class.componentType

      throws:
        UnsupportedOperationException if the array is empty
      Returns:
        an array without its first element
      Since:
        5.0.0

    - #### public List<Long> toImmutableList()

      Converts this array to an immutable List of the same size, with each element added to the list.

      Returns:
        An immutable list containing the contents of this array.
      Since:
        6.0.0

    - #### public Set<Long> toImmutableSet()

      Converts this array to an immutable Set, with each unique element added to the set.

           long[] array = [1, 2, 3, 2, 1]
           Set expected = [1, 2, 3]
           assert array.toImmutableSet() == expected

      Returns:
        An immutable set containing the unique contents of this array.
      Since:
        6.0.0

    - #### public List<Long> toList()

      Converts this array to a List of the same size, with each element added to the list.

      Returns:
        A list containing the contents of this array.
      Since:
        1.0

    - #### public Set<Long> toSet()

      Converts this array to a Set, with each unique element added to the set.

           long[] array = [1, 2, 3, 2, 1]
           Set expected = [1, 2, 3]
           assert array.toSet() == expected

      Returns:
        A set containing the unique contents of this array.
      Since:
        1.8.0

    - #### public String toString()

      Returns the string representation of the given array.

           long[] array = [1, 2, 3, 2, 1]
           assert array.toString() == '[1, 2, 3, 2, 1]'

      Returns:
        the string representation
      Since:
        1.6.0

    - #### public List<Tuple2<Long, Integer>> withIndex()

      Zips a long array with indices in (value, index) order.

      Example usage:

           long[] nums = [42L, -1L]
           assert [[42L, 0], [-1L, 1]] == nums.withIndex()
           assert ["0: 42", "1: -1"] == nums.withIndex().collect { n, idx -> "$idx: $n" }

      Returns:
        a zipped list with indices
      See Also:
        DefaultGroovyMethods#withIndex(Iterable)#withIndex(Iterable)
      Since:
        5.0.0

    - #### public List<Tuple2<Long, Integer>> withIndex(int offset)

      Zips a long array with indices in (value, index) order starting from a given index.

      Example usage:

           long[] nums = [42L, -1L]
           assert [[42L, 5], [-1L, 6]] == nums.withIndex(5)
           assert ["5: 42", "6: -1"] == nums.withIndex(5).collect { n, idx -> "$idx: $n" }

      Parameters:
        `offset` - an index to start from
      Returns:
        a zipped list with indices
      See Also:
        DefaultGroovyMethods#withIndex(Iterable)#withIndex(Iterable)
      Since:
        5.0.0

    - #### public List<Tuple2<Long, Long>> zip(long[] other)

      A list of all the pairs from two arrays.

           long[] small = [1L, 2L, 3L]
           long[] large = [100L, 200L, 300L]
           assert [101L, 202L, 303L] == small.zip(large).collect{ a, b -> a + b }
           assert [small, large].transpose() == small.zip(large)

      Parameters:
        `other` - another long[]
      Returns:
        a list of all the pairs from self and other
      Since:
        5.0.0

    - #### public Iterator<Tuple2<Long, Long>> zipping(long[] other)

      An iterator of all the pairs from two arrays.

           long[] small = [1L, 2L, 3L]
           long[] large = [100L, 200L, 300L]
           assert [101L, 202L, 303L] == small.zipping(large).collect{ a, b -> a + b }
           assert [small, large].transpose() == small.zipping(large).toList()

      Parameters:
        `other` - another long[]
      Returns:
        an iterator of all the pairs from self and other
      Since:
        5.0.0